'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckboxDocs = exports.LabelCheckbox = exports.styleSheet = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _react = require('react');

var _jssThemeReactor = require('jss-theme-reactor');

var _SwitchBase = require('../internal/SwitchBase');

var _withSwitchLabel = require('../internal/withSwitchLabel');

var _withSwitchLabel2 = _interopRequireDefault(_withSwitchLabel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//  weak

var styleSheet = exports.styleSheet = (0, _jssThemeReactor.createStyleSheet)('MuiCheckbox', function (theme) {
  return {
    default: {
      color: theme.palette.text.secondary
    },
    checked: {
      color: theme.palette.accent[500]
    },
    disabled: {
      color: theme.palette.action.disabled
    }
  };
});

var Checkbox = (0, _SwitchBase.createSwitch)({ styleSheet: styleSheet });

Checkbox.displayName = 'Checkbox';

exports.default = Checkbox;


var LabelCheckbox = (0, _withSwitchLabel2.default)(Checkbox);

exports.LabelCheckbox = LabelCheckbox;

/**
 * [Checkboxes](https://material.io/guidelines/components/selection-controls.html#selection-controls-checkbox)
 * allow the user to select multiple options from a set.
 */

var CheckboxDocs = exports.CheckboxDocs = function () {
  function CheckboxDocs() {
    (0, _classCallCheck3.default)(this, CheckboxDocs);
  }

  (0, _createClass3.default)(CheckboxDocs, [{
    key: 'render',
    value: function render() {}
  }]);
  return CheckboxDocs;
}();

CheckboxDocs.propTypes = {
  /**
   * If `true`, the component is checked.
   */
  checked: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string]),
  /**
   * The CSS class name of the root element when checked.
   */
  checkedClassName: _react.PropTypes.string,
  /**
   * The icon to display when the component is checked.
   */
  checkedIcon: _react.PropTypes.node,
  /**
   * The CSS class name of the root element.
   */
  className: _react.PropTypes.string,
  /**
   * @ignore
   */
  defaultChecked: _react.PropTypes.bool,
  /**
   * If `true`, the switch will be disabled.
   */
  disabled: _react.PropTypes.bool,
  /**
   * The CSS class name of the root element when disabled.
   */
  disabledClassName: _react.PropTypes.string,
  /**
   * The icon to display when the component is unchecked.
   * If a string is provided, it will be used as a font ligature.
   */
  icon: _react.PropTypes.node,
  /*
   * @ignore
   */
  name: _react.PropTypes.string,
  /**
   * Callback fired when the state is changed.
   *
   * @param {object} event `change` event
   * @param {boolean} checked The `checked` value of the switch
   */
  onChange: _react.PropTypes.func,
  /**
   * If `false`, the ripple effect will be disabled.
   */
  ripple: _react.PropTypes.bool,
  /**
   * @ignore
   */
  tabIndex: _react.PropTypes.string,
  /**
   * The value of the component.
   */
  value: _react.PropTypes.string
};