'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioDocs = exports.LabelRadio = exports.styleSheet = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _jsx2 = require('babel-runtime/helpers/jsx');

var _jsx3 = _interopRequireDefault(_jsx2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _jssThemeReactor = require('jss-theme-reactor');

var _SwitchBase = require('../internal/SwitchBase');

var _withSwitchLabel = require('../internal/withSwitchLabel');

var _withSwitchLabel2 = _interopRequireDefault(_withSwitchLabel);

var _radioButtonChecked = require('../svg-icons/radio-button-checked');

var _radioButtonChecked2 = _interopRequireDefault(_radioButtonChecked);

var _radioButtonUnchecked = require('../svg-icons/radio-button-unchecked');

var _radioButtonUnchecked2 = _interopRequireDefault(_radioButtonUnchecked);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//  weak

var styleSheet = exports.styleSheet = (0, _jssThemeReactor.createStyleSheet)('MuiRadio', function (theme) {
  return {
    default: {
      color: theme.palette.text.secondary
    },
    checked: {
      color: theme.palette.accent[500]
    },
    disabled: {
      color: theme.palette.action.disabled
    }
  };
});

var Radio = (0, _SwitchBase.createSwitch)({
  styleSheet: styleSheet,
  inputType: 'radio',
  defaultIcon: (0, _jsx3.default)(_radioButtonUnchecked2.default, {}),
  defaultCheckedIcon: (0, _jsx3.default)(_radioButtonChecked2.default, {})
});

Radio.displayName = 'Radio';

exports.default = Radio;


var LabelRadio = (0, _withSwitchLabel2.default)(Radio);

exports.LabelRadio = LabelRadio;

/**
 * [Radio buttons](https://www.google.com/design/spec/components/selection-controls.html#selection-controls-radio-button)
 * are switches used for selection from multiple options.
 */

var RadioDocs = exports.RadioDocs = function () {
  function RadioDocs() {
    (0, _classCallCheck3.default)(this, RadioDocs);
  }

  (0, _createClass3.default)(RadioDocs, [{
    key: 'render',
    value: function render() {}
  }]);
  return RadioDocs;
}();

RadioDocs.propTypes = {
  /**
   * If `true`, the component appears selected.
   */
  checked: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.string]),
  /**
   * The CSS class name of the root element when selected.
   */
  checkedClassName: _react.PropTypes.string,
  /**
   * The icon to display when selected.
   */
  checkedIcon: _react.PropTypes.node,
  /**
   * The CSS class name of the root element.
   */
  className: _react.PropTypes.string,
  /**
   * @ignore
   */
  defaultChecked: _react.PropTypes.bool,
  /**
   * If `true`, the component disabled.
   */
  disabled: _react.PropTypes.bool,
  /**
   * The CSS class name of the root element when disabled.
   */
  disabledClassName: _react.PropTypes.string,
  /**
   * The icon to display when the component is unselected.
   */
  icon: _react.PropTypes.node,
  /*
   * @ignore
   */
  name: _react.PropTypes.string,
  /**
   * Callback fired when the state is changed.
   *
   * @param {object} event `change` event
   * @param {boolean} checked The `checked` value of the switch
   */
  onChange: _react.PropTypes.func,
  /**
   * If `false`, the ripple effect will be disabled.
   */
  ripple: _react.PropTypes.bool,
  /**
   * @ignore
   */
  tabIndex: _react.PropTypes.string,
  /**
   * The value of the component.
   */
  value: _react.PropTypes.string
};